# Generated by Django 3.2.2 on 2021-05-11 14:33
from django.conf import settings
from django.contrib.auth.hashers import make_password
from django.db import migrations


def add_user(apps, schema_editor):
    """Создаем Льву юзера"""
    User = apps.get_model(*settings.AUTH_USER_MODEL.split('.'))
    User.objects.create(
        username='leo',
        email='leo@fat.ru',
        password=make_password('s3cr3tp4ssw0rd!'),
    )


def remove_user(apps, schema_editor):
    """Удаляем юзера"""
    User = apps.get_model(*settings.AUTH_USER_MODEL.split('.'))
    User.objects.get(email='leo@fat.ru').delete()


def populate_posts(apps, schema_editor):
    """Наполняем базу постами, которые можно будет получить через API."""
    Post = apps.get_model('posts', 'Post')
    User = apps.get_model(*settings.AUTH_USER_MODEL.split('.'))
    author = User.objects.get(email='leo@fat.ru')
    posts_list = [
        {
            'text': '1 Февраля. 1860. [Ясная Поляна.]\n'
                    'Вчера была бессонница до 5 часов утра. '
                    'Читал о dégénérescence de l\'espèce humaine[42] и о том,'
                    ' как есть физическая высшая степень развития ума. '
                    'Я в этой степени. Машинально вспомнил молитву. Молиться кому? '
                    'Что такое Бог, представляемый себе так ясно, что можно просить Его,'
                    ' сообщаться с Ним? Ежели я и представляю себе такого, '
                    'то Он теряет для меня всякое величие. '
                    'Бог, которого можно просить и которому можно служить, '
                    'есть выражение слабости ума. Тем-то Он Бог, что всё Его '
                    'существо я не могу представить себе. Да Он и не существо,'
                    ' Он закон и сила. '
                    'Пусть останется эта страничка памятником моего убеждения в силе ума.',
            'author': author,
        },
        {
            'text': '22 Мая 1860. Троицын день. Дождь. '
                    'Читал Ауэрбаха и Reineke-Fuchs. — Перечел записку — дельно. '
                    'Пропустил всё веселье — грустно. '
                    'Нужно любить всех, и Филата, и Ивана, и быть с ними проще. '
                    'Обругал старосту и Матвея.',
            'author': author,
        },
        {
            'text': '[8/20 апреля.] 20 Апреля. Скверный день. Книги покупал. '
                    'Денег уж мало. Любовался причастием. '
                    'Пустился в беседу с дураком Танеевым. '
                    'Обедал у Галах[овых], барышни ни то ни се. '
                    'Вечер[ом] увертюра Кориолана и симфония Мендельсона, '
                    'не слишком затронула. Шлялся, пошло, глупо. '
                    'Какое-то сосущее чувство недовольства собой.',
            'author': author,
        },
        {
            'text': '6 Мая. 301214 [Ясная Поляна.] Не писал дней 10. Ехал с М-me Фет, скучал.'
                    ' — В Туле Ауербахи, Головачев, Воейк[ов] для хаоса. '
                    'Тетинька грустна и постарела, Сережа — хорош во всех отношениях, '
                    'только празден. Меня назначили мировым посредником, я принял. '
                    '— Поехал в Тулу, много болтал и начинаю гордиться и потому глуп.'
                    ' — Марков отказался от соредактор[ства] в журнале. — И вообще мысль журнала слабеет.'
                    ' В Пирогове хаос, и с Сережей ничего не сделал. '
                    'Забыл день у Берсов приятный, но на Лизе не смею жениться. —'
                    '\nЗавтра с утра Поликушка и читать положения. Вечером приготовить программу школы и лекцию.',
            'author': author,
        },
        {
            'text': '25 Июня. Замечательная ссора с Тургеневым; окончательная— он подлец совершенный, '
                    'но я думаю, что со временем не выдержу и прощу его. — '
                    'Посредничество дало мало матерьялов, а поссорило меня со всеми помещиками окончательно'
                    ' и расстроило здоровье, кажется, тоже окончательно. '
                    'В школе идет порядок, но, боюсь, безжизненный. Я не хожу от болезни. Написал програм[му].',
            'author': author,
        },
        {
            'text': '[8?] Октября. Ясная Поляна. Вчера получил письмо от Тургенева, '
                    'в кот[ором] он обвиняет меня в том, что я рассказываю, что он трус, '
                    'и распространяю копии с письма моего. Написал ему, что это вздор, и '
                    'послал сверх того письмо: Вы называете мой поступок бесчестным, '
                    'вы прежде хотели мне дать в рожу, а я считаю себя виноватым, '
                    'прошу извинения и от вызова отказываюсь.'
                    ' — У меня два студента, школа идет хуже. Я начинаю разочаровываться в журнале. —',
            'author': author,
        },
        {
            'text': '[ Марта. Пироговский поп тихим голосом говорит: мы ее распетрушили, '
                    'С[ергей] Н[иколаевич]. Сережа говорит: еду за границу.'
                    ' Теперь игры нет, а может и выиграю. Прокофий дворовый говорит: '
                    'кабы мы были люди натуральные. Дворовый кучер жаловался, '
                    'что ему ничего не дают за найденные векселя. В ноги. — Я получил оную расписку. '
                    'Обида. Анисим староста с сочувствием рассказал, как — не будь плох — '
                    'остановил бурлака за нечаянный ушиб, но до крови!!!! '
                    'Мы недавно почувствовали, что страшно наше счастье. '
                    'Смерть и всё кончено. Неужели кончено? Бог. Мы молились.'
                    ' Мне хотелось чувствовать, что счастье это не случай, а Мое.[94]',
            'author': author,
        },
        {
            'text': '20 Марта. Погода чудная. Здоров. Ездил в Тулу верхом. Крупные мысли! '
                    'План истории Напо[леона] и Алек[сандра] не ослабел. '
                    'Поэма, героем к[оторо]й б[ыл] бы по праву человек, около к[отор]ого все группируется,'
                    ' и герой — этот человек. Читал — Marmont’а. В. А. Перовского плен. '
                    'Даву — казнить. Критика Маркова — плохо. Дорожит мыслью и сердится. '
                    'Сам-то ты что сделаешь? А силы, силы страшные! '
                    'Языков сказал, что объясняю речи — длинно — правда. Короче, короче.',
            'author': author,
        },
        {
            'text': '21 Марта. Погода чудная. Соня больна. Я досадую, что она слаба в боли. '
                    'Сережа мучает меня болезнью. '
                    'Хозяйство скотное веселит и хорошо. Ragus’a всё читаю с отметками. '
                    'Вечером писал сцену моста — плохо. —',
            'author': author,
        },
        {
            'text': '22. Мигрень, не писал.',
            'author': author,
        },
    ]
    Post.objects.bulk_create([Post(**post) for post in posts_list])


def delete_posts(apps, schema_editor):
    """Удаляем посты из базы."""
    Post = apps.get_model('posts', 'Post')
    User = apps.get_model(*settings.AUTH_USER_MODEL.split('.'))
    author = User.objects.get(email='leo@fat.ru')
    Post.objects.filter(author=author).delete()


class Migration(migrations.Migration):
    dependencies = [
        ('posts', '0001_initial'),
    ]

    operations = [
        migrations.RunPython(add_user, remove_user),
        migrations.RunPython(populate_posts, delete_posts),
    ]
